diff --git a/src/backend/commands/tablecmds.c b/src/backend/commands/tablecmds.c
index c4b0011..2d8d419 100644
--- a/src/backend/commands/tablecmds.c
+++ b/src/backend/commands/tablecmds.c
@@ -2310,7 +2310,7 @@ StoreCatalogInheritance1(Oid relationId, Oid parentOid,
 
 	simple_heap_insert(inhRelation, tuple);
 
-	CatalogUpdateIndexes(inhRelation, tuple);
+	CatalogUpdateIndexes(inhRelation, tuple, false, NULL);
 
 	heap_freetuple(tuple);
 
@@ -2397,11 +2397,16 @@ SetRelationHasSubclass(Oid relationId, bool relhassubclass)
 
 	if (classtuple->relhassubclass != relhassubclass)
 	{
+		bool		warm_update;
+		Bitmapset	*modified_attrs;
+
 		classtuple->relhassubclass = relhassubclass;
-		simple_heap_update(relationRelation, &tuple->t_self, tuple);
+		simple_heap_update(relationRelation, &tuple->t_self, tuple,
+				&warm_update, &modified_attrs);
 
 		/* keep the catalog indexes up to date */
-		CatalogUpdateIndexes(relationRelation, tuple);
+		CatalogUpdateIndexes(relationRelation, tuple, warm_update,
+				modified_attrs);
 	}
 	else
 	{
@@ -2477,6 +2482,8 @@ renameatt_internal(Oid myrelid,
 	HeapTuple	atttup;
 	Form_pg_attribute attform;
 	AttrNumber	attnum;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/*
 	 * Grab an exclusive lock on the target table, which we will NOT release
@@ -2592,10 +2599,11 @@ renameatt_internal(Oid myrelid,
 	/* apply the update */
 	namestrcpy(&(attform->attname), newattname);
 
-	simple_heap_update(attrelation, &atttup->t_self, atttup);
+	simple_heap_update(attrelation, &atttup->t_self, atttup, &warm_update,
+			&modified_attrs);
 
 	/* keep system catalog indexes current */
-	CatalogUpdateIndexes(attrelation, atttup);
+	CatalogUpdateIndexes(attrelation, atttup, warm_update, modified_attrs);
 
 	InvokeObjectPostAlterHook(RelationRelationId, myrelid, attnum);
 
@@ -2871,6 +2879,8 @@ RenameRelationInternal(Oid myrelid, const char *newrelname, bool is_internal)
 	HeapTuple	reltup;
 	Form_pg_class relform;
 	Oid			namespaceId;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/*
 	 * Grab an exclusive lock on the target table, index, sequence, view,
@@ -2902,10 +2912,11 @@ RenameRelationInternal(Oid myrelid, const char *newrelname, bool is_internal)
 	 */
 	namestrcpy(&(relform->relname), newrelname);
 
-	simple_heap_update(relrelation, &reltup->t_self, reltup);
+	simple_heap_update(relrelation, &reltup->t_self, reltup, &warm_update,
+			&modified_attrs);
 
 	/* keep the system catalog indexes current */
-	CatalogUpdateIndexes(relrelation, reltup);
+	CatalogUpdateIndexes(relrelation, reltup, warm_update, modified_attrs);
 
 	InvokeObjectPostAlterHookArg(RelationRelationId, myrelid, 0,
 								 InvalidOid, is_internal);
@@ -5039,6 +5050,8 @@ ATExecAddColumn(List **wqueue, AlteredTableInfo *tab, Relation rel,
 	ListCell   *child;
 	AclResult	aclresult;
 	ObjectAddress address;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/* At top level, permission check was done in ATPrepCmd, else do it */
 	if (recursing)
@@ -5069,6 +5082,8 @@ ATExecAddColumn(List **wqueue, AlteredTableInfo *tab, Relation rel,
 			Oid			ctypeId;
 			int32		ctypmod;
 			Oid			ccollid;
+			bool		warm_update;
+			Bitmapset	*modified_attrs;
 
 			/* Child column must match on type, typmod, and collation */
 			typenameTypeIdAndMod(NULL, colDef->typeName, &ctypeId, &ctypmod);
@@ -5097,8 +5112,9 @@ ATExecAddColumn(List **wqueue, AlteredTableInfo *tab, Relation rel,
 
 			/* Bump the existing child att's inhcount */
 			childatt->attinhcount++;
-			simple_heap_update(attrdesc, &tuple->t_self, tuple);
-			CatalogUpdateIndexes(attrdesc, tuple);
+			simple_heap_update(attrdesc, &tuple->t_self, tuple, &warm_update,
+					&modified_attrs);
+			CatalogUpdateIndexes(attrdesc, tuple, warm_update, modified_attrs);
 
 			heap_freetuple(tuple);
 
@@ -5191,10 +5207,11 @@ ATExecAddColumn(List **wqueue, AlteredTableInfo *tab, Relation rel,
 	else
 		((Form_pg_class) GETSTRUCT(reltup))->relnatts = newattnum;
 
-	simple_heap_update(pgclass, &reltup->t_self, reltup);
+	simple_heap_update(pgclass, &reltup->t_self, reltup, &warm_update,
+			&modified_attrs);
 
 	/* keep catalog indexes current */
-	CatalogUpdateIndexes(pgclass, reltup);
+	CatalogUpdateIndexes(pgclass, reltup, warm_update, modified_attrs);
 
 	heap_freetuple(reltup);
 
@@ -5628,12 +5645,16 @@ ATExecDropNotNull(Relation rel, const char *colName, LOCKMODE lockmode)
 	 */
 	if (((Form_pg_attribute) GETSTRUCT(tuple))->attnotnull)
 	{
+		bool		warm_update;
+		Bitmapset	*modified_attrs;
+
 		((Form_pg_attribute) GETSTRUCT(tuple))->attnotnull = FALSE;
 
-		simple_heap_update(attr_rel, &tuple->t_self, tuple);
+		simple_heap_update(attr_rel, &tuple->t_self, tuple, &warm_update,
+				&modified_attrs);
 
 		/* keep the system catalog indexes current */
-		CatalogUpdateIndexes(attr_rel, tuple);
+		CatalogUpdateIndexes(attr_rel, tuple, warm_update, modified_attrs);
 
 		ObjectAddressSubSet(address, RelationRelationId,
 							RelationGetRelid(rel), attnum);
@@ -5706,12 +5727,16 @@ ATExecSetNotNull(AlteredTableInfo *tab, Relation rel,
 	 */
 	if (!((Form_pg_attribute) GETSTRUCT(tuple))->attnotnull)
 	{
+		bool		warm_update;
+		Bitmapset	*modified_attrs;
+
 		((Form_pg_attribute) GETSTRUCT(tuple))->attnotnull = TRUE;
 
-		simple_heap_update(attr_rel, &tuple->t_self, tuple);
+		simple_heap_update(attr_rel, &tuple->t_self, tuple, &warm_update,
+				&modified_attrs);
 
 		/* keep the system catalog indexes current */
-		CatalogUpdateIndexes(attr_rel, tuple);
+		CatalogUpdateIndexes(attr_rel, tuple, warm_update, modified_attrs);
 
 		/* Tell Phase 3 it needs to test the constraint */
 		tab->new_notnull = true;
@@ -5833,6 +5858,8 @@ ATExecSetStatistics(Relation rel, const char *colName, Node *newValue, LOCKMODE
 	Form_pg_attribute attrtuple;
 	AttrNumber	attnum;
 	ObjectAddress address;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	Assert(IsA(newValue, Integer));
 	newtarget = intVal(newValue);
@@ -5876,10 +5903,11 @@ ATExecSetStatistics(Relation rel, const char *colName, Node *newValue, LOCKMODE
 
 	attrtuple->attstattarget = newtarget;
 
-	simple_heap_update(attrelation, &tuple->t_self, tuple);
+	simple_heap_update(attrelation, &tuple->t_self, tuple, &warm_update,
+			&modified_attrs);
 
 	/* keep system catalog indexes current */
-	CatalogUpdateIndexes(attrelation, tuple);
+	CatalogUpdateIndexes(attrelation, tuple, warm_update, modified_attrs);
 
 	InvokeObjectPostAlterHook(RelationRelationId,
 							  RelationGetRelid(rel),
@@ -5912,6 +5940,8 @@ ATExecSetOptions(Relation rel, const char *colName, Node *options,
 	Datum		repl_val[Natts_pg_attribute];
 	bool		repl_null[Natts_pg_attribute];
 	bool		repl_repl[Natts_pg_attribute];
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	attrelation = heap_open(AttributeRelationId, RowExclusiveLock);
 
@@ -5953,8 +5983,9 @@ ATExecSetOptions(Relation rel, const char *colName, Node *options,
 								 repl_val, repl_null, repl_repl);
 
 	/* Update system catalog. */
-	simple_heap_update(attrelation, &newtuple->t_self, newtuple);
-	CatalogUpdateIndexes(attrelation, newtuple);
+	simple_heap_update(attrelation, &newtuple->t_self, newtuple, &warm_update,
+			&modified_attrs);
+	CatalogUpdateIndexes(attrelation, newtuple, warm_update, modified_attrs);
 
 	InvokeObjectPostAlterHook(RelationRelationId,
 							  RelationGetRelid(rel),
@@ -5986,6 +6017,8 @@ ATExecSetStorage(Relation rel, const char *colName, Node *newValue, LOCKMODE loc
 	Form_pg_attribute attrtuple;
 	AttrNumber	attnum;
 	ObjectAddress address;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	Assert(IsA(newValue, String));
 	storagemode = strVal(newValue);
@@ -6037,10 +6070,11 @@ ATExecSetStorage(Relation rel, const char *colName, Node *newValue, LOCKMODE loc
 				 errmsg("column data type %s can only have storage PLAIN",
 						format_type_be(attrtuple->atttypid))));
 
-	simple_heap_update(attrelation, &tuple->t_self, tuple);
+	simple_heap_update(attrelation, &tuple->t_self, tuple, &warm_update,
+			&modified_attrs);
 
 	/* keep system catalog indexes current */
-	CatalogUpdateIndexes(attrelation, tuple);
+	CatalogUpdateIndexes(attrelation, tuple, warm_update, modified_attrs);
 
 	InvokeObjectPostAlterHook(RelationRelationId,
 							  RelationGetRelid(rel),
@@ -6275,13 +6309,18 @@ ATExecDropColumn(List **wqueue, Relation rel, const char *colName,
 				}
 				else
 				{
+					bool		warm_update;
+					Bitmapset	*modified_attrs;
+
 					/* Child column must survive my deletion */
 					childatt->attinhcount--;
 
-					simple_heap_update(attr_rel, &tuple->t_self, tuple);
+					simple_heap_update(attr_rel, &tuple->t_self, tuple,
+							&warm_update, &modified_attrs);
 
 					/* keep the system catalog indexes current */
-					CatalogUpdateIndexes(attr_rel, tuple);
+					CatalogUpdateIndexes(attr_rel, tuple, warm_update,
+							modified_attrs);
 
 					/* Make update visible */
 					CommandCounterIncrement();
@@ -6289,6 +6328,9 @@ ATExecDropColumn(List **wqueue, Relation rel, const char *colName,
 			}
 			else
 			{
+				bool		warm_update;
+				Bitmapset	*modified_attrs;
+
 				/*
 				 * If we were told to drop ONLY in this table (no recursion),
 				 * we need to mark the inheritors' attributes as locally
@@ -6297,10 +6339,12 @@ ATExecDropColumn(List **wqueue, Relation rel, const char *colName,
 				childatt->attinhcount--;
 				childatt->attislocal = true;
 
-				simple_heap_update(attr_rel, &tuple->t_self, tuple);
+				simple_heap_update(attr_rel, &tuple->t_self, tuple,
+						&warm_update, &modified_attrs);
 
 				/* keep the system catalog indexes current */
-				CatalogUpdateIndexes(attr_rel, tuple);
+				CatalogUpdateIndexes(attr_rel, tuple, warm_update,
+						modified_attrs);
 
 				/* Make update visible */
 				CommandCounterIncrement();
@@ -6333,6 +6377,8 @@ ATExecDropColumn(List **wqueue, Relation rel, const char *colName,
 		Relation	class_rel;
 		Form_pg_class tuple_class;
 		AlteredTableInfo *tab;
+		bool		warm_update;
+		Bitmapset	*modified_attrs;
 
 		class_rel = heap_open(RelationRelationId, RowExclusiveLock);
 
@@ -6344,10 +6390,11 @@ ATExecDropColumn(List **wqueue, Relation rel, const char *colName,
 		tuple_class = (Form_pg_class) GETSTRUCT(tuple);
 
 		tuple_class->relhasoids = false;
-		simple_heap_update(class_rel, &tuple->t_self, tuple);
+		simple_heap_update(class_rel, &tuple->t_self, tuple, &warm_update,
+				&modified_attrs);
 
 		/* Keep the catalog indexes up to date */
-		CatalogUpdateIndexes(class_rel, tuple);
+		CatalogUpdateIndexes(class_rel, tuple, warm_update, modified_attrs);
 
 		heap_close(class_rel, RowExclusiveLock);
 
@@ -7189,6 +7236,8 @@ ATExecAlterConstraint(Relation rel, AlterTableCmd *cmd,
 		SysScanDesc tgscan;
 		Relation	tgrel;
 		ListCell   *lc;
+		bool		warm_update;
+		Bitmapset	*modified_attrs;
 
 		/*
 		 * Now update the catalog, while we have the door open.
@@ -7197,8 +7246,9 @@ ATExecAlterConstraint(Relation rel, AlterTableCmd *cmd,
 		copy_con = (Form_pg_constraint) GETSTRUCT(copyTuple);
 		copy_con->condeferrable = cmdcon->deferrable;
 		copy_con->condeferred = cmdcon->initdeferred;
-		simple_heap_update(conrel, &copyTuple->t_self, copyTuple);
-		CatalogUpdateIndexes(conrel, copyTuple);
+		simple_heap_update(conrel, &copyTuple->t_self, copyTuple, &warm_update,
+				&modified_attrs);
+		CatalogUpdateIndexes(conrel, copyTuple, warm_update, modified_attrs);
 
 		InvokeObjectPostAlterHook(ConstraintRelationId,
 								  HeapTupleGetOid(contuple), 0);
@@ -7223,6 +7273,8 @@ ATExecAlterConstraint(Relation rel, AlterTableCmd *cmd,
 		{
 			Form_pg_trigger tgform = (Form_pg_trigger) GETSTRUCT(tgtuple);
 			Form_pg_trigger copy_tg;
+			bool		warm_update;
+			Bitmapset	*modified_attrs;
 
 			/*
 			 * Remember OIDs of other relation(s) involved in FK constraint.
@@ -7251,8 +7303,9 @@ ATExecAlterConstraint(Relation rel, AlterTableCmd *cmd,
 
 			copy_tg->tgdeferrable = cmdcon->deferrable;
 			copy_tg->tginitdeferred = cmdcon->initdeferred;
-			simple_heap_update(tgrel, &copyTuple->t_self, copyTuple);
-			CatalogUpdateIndexes(tgrel, copyTuple);
+			simple_heap_update(tgrel, &copyTuple->t_self, copyTuple,
+					&warm_update, &modified_attrs);
+			CatalogUpdateIndexes(tgrel, copyTuple, warm_update, modified_attrs);
 
 			InvokeObjectPostAlterHook(TriggerRelationId,
 									  HeapTupleGetOid(tgtuple), 0);
@@ -7351,6 +7404,8 @@ ATExecValidateConstraint(Relation rel, char *constrName, bool recurse,
 	{
 		HeapTuple	copyTuple;
 		Form_pg_constraint copy_con;
+		bool		warm_update;
+		Bitmapset	*modified_attrs;
 
 		if (con->contype == CONSTRAINT_FOREIGN)
 		{
@@ -7438,8 +7493,9 @@ ATExecValidateConstraint(Relation rel, char *constrName, bool recurse,
 		copyTuple = heap_copytuple(tuple);
 		copy_con = (Form_pg_constraint) GETSTRUCT(copyTuple);
 		copy_con->convalidated = true;
-		simple_heap_update(conrel, &copyTuple->t_self, copyTuple);
-		CatalogUpdateIndexes(conrel, copyTuple);
+		simple_heap_update(conrel, &copyTuple->t_self, copyTuple, &warm_update,
+				&modified_attrs);
+		CatalogUpdateIndexes(conrel, copyTuple, warm_update, modified_attrs);
 
 		InvokeObjectPostAlterHook(ConstraintRelationId,
 								  HeapTupleGetOid(tuple), 0);
@@ -8339,10 +8395,14 @@ ATExecDropConstraint(Relation rel, const char *constrName,
 			}
 			else
 			{
+				bool		warm_update;
+				Bitmapset	*modified_attrs;
+
 				/* Child constraint must survive my deletion */
 				con->coninhcount--;
-				simple_heap_update(conrel, &copy_tuple->t_self, copy_tuple);
-				CatalogUpdateIndexes(conrel, copy_tuple);
+				simple_heap_update(conrel, &copy_tuple->t_self, copy_tuple,
+						&warm_update, &modified_attrs);
+				CatalogUpdateIndexes(conrel, copy_tuple, warm_update, modified_attrs);
 
 				/* Make update visible */
 				CommandCounterIncrement();
@@ -8350,6 +8410,9 @@ ATExecDropConstraint(Relation rel, const char *constrName,
 		}
 		else
 		{
+			bool		warm_update;
+			Bitmapset	*modified_attrs;
+
 			/*
 			 * If we were told to drop ONLY in this table (no recursion), we
 			 * need to mark the inheritors' constraints as locally defined
@@ -8358,8 +8421,10 @@ ATExecDropConstraint(Relation rel, const char *constrName,
 			con->coninhcount--;
 			con->conislocal = true;
 
-			simple_heap_update(conrel, &copy_tuple->t_self, copy_tuple);
-			CatalogUpdateIndexes(conrel, copy_tuple);
+			simple_heap_update(conrel, &copy_tuple->t_self, copy_tuple,
+					&warm_update, &modified_attrs);
+			CatalogUpdateIndexes(conrel, copy_tuple, warm_update,
+					modified_attrs);
 
 			/* Make update visible */
 			CommandCounterIncrement();
@@ -8675,6 +8740,8 @@ ATExecAlterColumnType(AlteredTableInfo *tab, Relation rel,
 	SysScanDesc scan;
 	HeapTuple	depTup;
 	ObjectAddress address;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	attrelation = heap_open(AttributeRelationId, RowExclusiveLock);
 
@@ -9005,10 +9072,11 @@ ATExecAlterColumnType(AlteredTableInfo *tab, Relation rel,
 
 	ReleaseSysCache(typeTuple);
 
-	simple_heap_update(attrelation, &heapTup->t_self, heapTup);
+	simple_heap_update(attrelation, &heapTup->t_self, heapTup, &warm_update,
+			&modified_attrs);
 
 	/* keep system catalog indexes current */
-	CatalogUpdateIndexes(attrelation, heapTup);
+	CatalogUpdateIndexes(attrelation, heapTup, warm_update, modified_attrs);
 
 	heap_close(attrelation, RowExclusiveLock);
 
@@ -9079,6 +9147,8 @@ ATExecAlterColumnGenericOptions(Relation rel,
 	Form_pg_attribute atttableform;
 	AttrNumber	attnum;
 	ObjectAddress address;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	if (options == NIL)
 		return InvalidObjectAddress;
@@ -9146,8 +9216,9 @@ ATExecAlterColumnGenericOptions(Relation rel,
 	newtuple = heap_modify_tuple(tuple, RelationGetDescr(attrel),
 								 repl_val, repl_null, repl_repl);
 
-	simple_heap_update(attrel, &newtuple->t_self, newtuple);
-	CatalogUpdateIndexes(attrel, newtuple);
+	simple_heap_update(attrel, &newtuple->t_self, newtuple, &warm_update,
+			&modified_attrs);
+	CatalogUpdateIndexes(attrel, newtuple, warm_update, modified_attrs);
 
 	InvokeObjectPostAlterHook(RelationRelationId,
 							  RelationGetRelid(rel),
@@ -9617,6 +9688,8 @@ ATExecChangeOwner(Oid relationOid, Oid newOwnerId, bool recursing, LOCKMODE lock
 		Datum		aclDatum;
 		bool		isNull;
 		HeapTuple	newtuple;
+		bool		warm_update;
+		Bitmapset	*modified_attrs;
 
 		/* skip permission checks when recursing to index or toast table */
 		if (!recursing)
@@ -9667,8 +9740,9 @@ ATExecChangeOwner(Oid relationOid, Oid newOwnerId, bool recursing, LOCKMODE lock
 
 		newtuple = heap_modify_tuple(tuple, RelationGetDescr(class_rel), repl_val, repl_null, repl_repl);
 
-		simple_heap_update(class_rel, &newtuple->t_self, newtuple);
-		CatalogUpdateIndexes(class_rel, newtuple);
+		simple_heap_update(class_rel, &newtuple->t_self, newtuple,
+				&warm_update, &modified_attrs);
+		CatalogUpdateIndexes(class_rel, newtuple, warm_update, modified_attrs);
 
 		heap_freetuple(newtuple);
 
@@ -9770,6 +9844,8 @@ change_owner_fix_column_acls(Oid relationOid, Oid oldOwnerId, Oid newOwnerId)
 		Datum		aclDatum;
 		bool		isNull;
 		HeapTuple	newtuple;
+		bool		warm_update;
+		Bitmapset	*modified_attrs;
 
 		/* Ignore dropped columns */
 		if (att->attisdropped)
@@ -9795,8 +9871,10 @@ change_owner_fix_column_acls(Oid relationOid, Oid oldOwnerId, Oid newOwnerId)
 									 RelationGetDescr(attRelation),
 									 repl_val, repl_null, repl_repl);
 
-		simple_heap_update(attRelation, &newtuple->t_self, newtuple);
-		CatalogUpdateIndexes(attRelation, newtuple);
+		simple_heap_update(attRelation, &newtuple->t_self, newtuple,
+				&warm_update, &modified_attrs);
+		CatalogUpdateIndexes(attRelation, newtuple, warm_update,
+				modified_attrs);
 
 		heap_freetuple(newtuple);
 	}
@@ -9966,6 +10044,8 @@ ATExecSetRelOptions(Relation rel, List *defList, AlterTableType operation,
 	bool		repl_null[Natts_pg_class];
 	bool		repl_repl[Natts_pg_class];
 	static char *validnsps[] = HEAP_RELOPT_NAMESPACES;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	if (defList == NIL && operation != AT_ReplaceRelOptions)
 		return;					/* nothing to do */
@@ -10073,9 +10153,10 @@ ATExecSetRelOptions(Relation rel, List *defList, AlterTableType operation,
 	newtuple = heap_modify_tuple(tuple, RelationGetDescr(pgclass),
 								 repl_val, repl_null, repl_repl);
 
-	simple_heap_update(pgclass, &newtuple->t_self, newtuple);
+	simple_heap_update(pgclass, &newtuple->t_self, newtuple, &warm_update,
+			&modified_attrs);
 
-	CatalogUpdateIndexes(pgclass, newtuple);
+	CatalogUpdateIndexes(pgclass, newtuple, warm_update, modified_attrs);
 
 	InvokeObjectPostAlterHook(RelationRelationId, RelationGetRelid(rel), 0);
 
@@ -10088,6 +10169,8 @@ ATExecSetRelOptions(Relation rel, List *defList, AlterTableType operation,
 	{
 		Relation	toastrel;
 		Oid			toastid = rel->rd_rel->reltoastrelid;
+		bool		warm_update;
+		Bitmapset	*modified_attrs;
 
 		toastrel = heap_open(toastid, lockmode);
 
@@ -10132,9 +10215,9 @@ ATExecSetRelOptions(Relation rel, List *defList, AlterTableType operation,
 		newtuple = heap_modify_tuple(tuple, RelationGetDescr(pgclass),
 									 repl_val, repl_null, repl_repl);
 
-		simple_heap_update(pgclass, &newtuple->t_self, newtuple);
+		simple_heap_update(pgclass, &newtuple->t_self, newtuple, &warm_update, &modified_attrs);
 
-		CatalogUpdateIndexes(pgclass, newtuple);
+		CatalogUpdateIndexes(pgclass, newtuple, warm_update, modified_attrs);
 
 		InvokeObjectPostAlterHookArg(RelationRelationId,
 									 RelationGetRelid(toastrel), 0,
@@ -10169,6 +10252,8 @@ ATExecSetTableSpace(Oid tableOid, Oid newTableSpace, LOCKMODE lockmode)
 	ForkNumber	forkNum;
 	List	   *reltoastidxids = NIL;
 	ListCell   *lc;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/*
 	 * Need lock here in case we are recursing to toast table or index
@@ -10295,8 +10380,9 @@ ATExecSetTableSpace(Oid tableOid, Oid newTableSpace, LOCKMODE lockmode)
 	/* update the pg_class row */
 	rd_rel->reltablespace = (newTableSpace == MyDatabaseTableSpace) ? InvalidOid : newTableSpace;
 	rd_rel->relfilenode = newrelfilenode;
-	simple_heap_update(pg_class, &tuple->t_self, tuple);
-	CatalogUpdateIndexes(pg_class, tuple);
+	simple_heap_update(pg_class, &tuple->t_self, tuple, &warm_update,
+			&modified_attrs);
+	CatalogUpdateIndexes(pg_class, tuple, warm_update, modified_attrs);
 
 	InvokeObjectPostAlterHook(RelationRelationId, RelationGetRelid(rel), 0);
 
@@ -10901,6 +10987,9 @@ MergeAttributesIntoExisting(Relation child_rel, Relation parent_rel)
 										  attributeName);
 		if (HeapTupleIsValid(tuple))
 		{
+			bool		warm_update;
+			Bitmapset	*modified_attrs;
+
 			/* Check they are same type, typmod, and collation */
 			Form_pg_attribute childatt = (Form_pg_attribute) GETSTRUCT(tuple);
 
@@ -10946,8 +11035,9 @@ MergeAttributesIntoExisting(Relation child_rel, Relation parent_rel)
 				childatt->attislocal = false;
 			}
 
-			simple_heap_update(attrrel, &tuple->t_self, tuple);
-			CatalogUpdateIndexes(attrrel, tuple);
+			simple_heap_update(attrrel, &tuple->t_self, tuple, &warm_update,
+					&modified_attrs);
+			CatalogUpdateIndexes(attrrel, tuple, warm_update, modified_attrs);
 			heap_freetuple(tuple);
 		}
 		else
@@ -10976,6 +11066,8 @@ MergeAttributesIntoExisting(Relation child_rel, Relation parent_rel)
 		if (HeapTupleIsValid(tuple))
 		{
 			Form_pg_attribute childatt = (Form_pg_attribute) GETSTRUCT(tuple);
+			bool		warm_update;
+			Bitmapset	*modified_attrs;
 
 			/* See comments above; these changes should be the same */
 			childatt->attinhcount++;
@@ -10986,8 +11078,9 @@ MergeAttributesIntoExisting(Relation child_rel, Relation parent_rel)
 				childatt->attislocal = false;
 			}
 
-			simple_heap_update(attrrel, &tuple->t_self, tuple);
-			CatalogUpdateIndexes(attrrel, tuple);
+			simple_heap_update(attrrel, &tuple->t_self, tuple, &warm_update,
+					&modified_attrs);
+			CatalogUpdateIndexes(attrrel, tuple, warm_update, modified_attrs);
 			heap_freetuple(tuple);
 		}
 		else
@@ -11071,6 +11164,8 @@ MergeConstraintsIntoExisting(Relation child_rel, Relation parent_rel)
 		{
 			Form_pg_constraint child_con = (Form_pg_constraint) GETSTRUCT(child_tuple);
 			HeapTuple	child_copy;
+			bool		warm_update;
+			Bitmapset	*modified_attrs;
 
 			if (child_con->contype != CONSTRAINT_CHECK)
 				continue;
@@ -11124,8 +11219,10 @@ MergeConstraintsIntoExisting(Relation child_rel, Relation parent_rel)
 				child_con->conislocal = false;
 			}
 
-			simple_heap_update(catalog_relation, &child_copy->t_self, child_copy);
-			CatalogUpdateIndexes(catalog_relation, child_copy);
+			simple_heap_update(catalog_relation, &child_copy->t_self,
+					child_copy, &warm_update, &modified_attrs);
+			CatalogUpdateIndexes(catalog_relation, child_copy, warm_update,
+					modified_attrs);
 			heap_freetuple(child_copy);
 
 			found = true;
@@ -11290,13 +11387,17 @@ RemoveInheritance(Relation child_rel, Relation parent_rel)
 			/* Decrement inhcount and possibly set islocal to true */
 			HeapTuple	copyTuple = heap_copytuple(attributeTuple);
 			Form_pg_attribute copy_att = (Form_pg_attribute) GETSTRUCT(copyTuple);
+			bool		warm_update;
+			Bitmapset	*modified_attrs;
 
 			copy_att->attinhcount--;
 			if (copy_att->attinhcount == 0)
 				copy_att->attislocal = true;
 
-			simple_heap_update(catalogRelation, &copyTuple->t_self, copyTuple);
-			CatalogUpdateIndexes(catalogRelation, copyTuple);
+			simple_heap_update(catalogRelation, &copyTuple->t_self, copyTuple,
+					&warm_update, &modified_attrs);
+			CatalogUpdateIndexes(catalogRelation, copyTuple, warm_update,
+					modified_attrs);
 			heap_freetuple(copyTuple);
 		}
 	}
@@ -11361,6 +11462,8 @@ RemoveInheritance(Relation child_rel, Relation parent_rel)
 			/* Decrement inhcount and possibly set islocal to true */
 			HeapTuple	copyTuple = heap_copytuple(constraintTuple);
 			Form_pg_constraint copy_con = (Form_pg_constraint) GETSTRUCT(copyTuple);
+			bool		warm_update;
+			Bitmapset	*modified_attrs;
 
 			if (copy_con->coninhcount <= 0)		/* shouldn't happen */
 				elog(ERROR, "relation %u has non-inherited constraint \"%s\"",
@@ -11370,8 +11473,10 @@ RemoveInheritance(Relation child_rel, Relation parent_rel)
 			if (copy_con->coninhcount == 0)
 				copy_con->conislocal = true;
 
-			simple_heap_update(catalogRelation, &copyTuple->t_self, copyTuple);
-			CatalogUpdateIndexes(catalogRelation, copyTuple);
+			simple_heap_update(catalogRelation, &copyTuple->t_self, copyTuple,
+					&warm_update, &modified_attrs);
+			CatalogUpdateIndexes(catalogRelation, copyTuple, warm_update,
+					modified_attrs);
 			heap_freetuple(copyTuple);
 		}
 	}
@@ -11468,6 +11573,8 @@ ATExecAddOf(Relation rel, const TypeName *ofTypename, LOCKMODE lockmode)
 	ObjectAddress tableobj,
 				typeobj;
 	HeapTuple	classtuple;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/* Validate the type. */
 	typetuple = typenameType(NULL, ofTypename, NULL);
@@ -11571,8 +11678,10 @@ ATExecAddOf(Relation rel, const TypeName *ofTypename, LOCKMODE lockmode)
 	if (!HeapTupleIsValid(classtuple))
 		elog(ERROR, "cache lookup failed for relation %u", relid);
 	((Form_pg_class) GETSTRUCT(classtuple))->reloftype = typeid;
-	simple_heap_update(relationRelation, &classtuple->t_self, classtuple);
-	CatalogUpdateIndexes(relationRelation, classtuple);
+	simple_heap_update(relationRelation, &classtuple->t_self, classtuple,
+			&warm_update, &modified_attrs);
+	CatalogUpdateIndexes(relationRelation, classtuple, warm_update,
+			modified_attrs);
 
 	InvokeObjectPostAlterHook(RelationRelationId, relid, 0);
 
@@ -11596,6 +11705,8 @@ ATExecDropOf(Relation rel, LOCKMODE lockmode)
 	Oid			relid = RelationGetRelid(rel);
 	Relation	relationRelation;
 	HeapTuple	tuple;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	if (!OidIsValid(rel->rd_rel->reloftype))
 		ereport(ERROR,
@@ -11616,8 +11727,9 @@ ATExecDropOf(Relation rel, LOCKMODE lockmode)
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for relation %u", relid);
 	((Form_pg_class) GETSTRUCT(tuple))->reloftype = InvalidOid;
-	simple_heap_update(relationRelation, &tuple->t_self, tuple);
-	CatalogUpdateIndexes(relationRelation, tuple);
+	simple_heap_update(relationRelation, &tuple->t_self, tuple, &warm_update,
+			&modified_attrs);
+	CatalogUpdateIndexes(relationRelation, tuple, warm_update, modified_attrs);
 
 	InvokeObjectPostAlterHook(RelationRelationId, relid, 0);
 
@@ -11656,9 +11768,14 @@ relation_mark_replica_identity(Relation rel, char ri_type, Oid indexOid,
 	pg_class_form = (Form_pg_class) GETSTRUCT(pg_class_tuple);
 	if (pg_class_form->relreplident != ri_type)
 	{
+		bool		warm_update;
+		Bitmapset	*modified_attrs;
+
 		pg_class_form->relreplident = ri_type;
-		simple_heap_update(pg_class, &pg_class_tuple->t_self, pg_class_tuple);
-		CatalogUpdateIndexes(pg_class, pg_class_tuple);
+		simple_heap_update(pg_class, &pg_class_tuple->t_self, pg_class_tuple,
+				&warm_update, &modified_attrs);
+		CatalogUpdateIndexes(pg_class, pg_class_tuple, warm_update,
+				modified_attrs);
 	}
 	heap_close(pg_class, RowExclusiveLock);
 	heap_freetuple(pg_class_tuple);
@@ -11717,8 +11834,13 @@ relation_mark_replica_identity(Relation rel, char ri_type, Oid indexOid,
 
 		if (dirty)
 		{
-			simple_heap_update(pg_index, &pg_index_tuple->t_self, pg_index_tuple);
-			CatalogUpdateIndexes(pg_index, pg_index_tuple);
+			bool		warm_update;
+			Bitmapset	*modified_attrs;
+
+			simple_heap_update(pg_index, &pg_index_tuple->t_self,
+					pg_index_tuple, &warm_update, &modified_attrs);
+			CatalogUpdateIndexes(pg_index, pg_index_tuple, warm_update,
+					modified_attrs);
 			InvokeObjectPostAlterHookArg(IndexRelationId, thisIndexOid, 0,
 										 InvalidOid, is_internal);
 		}
@@ -11856,6 +11978,8 @@ ATExecEnableRowSecurity(Relation rel)
 	Relation	pg_class;
 	Oid			relid;
 	HeapTuple	tuple;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	relid = RelationGetRelid(rel);
 
@@ -11867,10 +11991,11 @@ ATExecEnableRowSecurity(Relation rel)
 		elog(ERROR, "cache lookup failed for relation %u", relid);
 
 	((Form_pg_class) GETSTRUCT(tuple))->relrowsecurity = true;
-	simple_heap_update(pg_class, &tuple->t_self, tuple);
+	simple_heap_update(pg_class, &tuple->t_self, tuple, &warm_update,
+			&modified_attrs);
 
 	/* keep catalog indexes current */
-	CatalogUpdateIndexes(pg_class, tuple);
+	CatalogUpdateIndexes(pg_class, tuple, warm_update, modified_attrs);
 
 	heap_close(pg_class, RowExclusiveLock);
 	heap_freetuple(tuple);
@@ -11882,6 +12007,8 @@ ATExecDisableRowSecurity(Relation rel)
 	Relation	pg_class;
 	Oid			relid;
 	HeapTuple	tuple;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	relid = RelationGetRelid(rel);
 
@@ -11894,10 +12021,11 @@ ATExecDisableRowSecurity(Relation rel)
 		elog(ERROR, "cache lookup failed for relation %u", relid);
 
 	((Form_pg_class) GETSTRUCT(tuple))->relrowsecurity = false;
-	simple_heap_update(pg_class, &tuple->t_self, tuple);
+	simple_heap_update(pg_class, &tuple->t_self, tuple, &warm_update,
+			&modified_attrs);
 
 	/* keep catalog indexes current */
-	CatalogUpdateIndexes(pg_class, tuple);
+	CatalogUpdateIndexes(pg_class, tuple, warm_update, modified_attrs);
 
 	heap_close(pg_class, RowExclusiveLock);
 	heap_freetuple(tuple);
@@ -11912,6 +12040,8 @@ ATExecForceNoForceRowSecurity(Relation rel, bool force_rls)
 	Relation	pg_class;
 	Oid			relid;
 	HeapTuple	tuple;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	relid = RelationGetRelid(rel);
 
@@ -11923,10 +12053,11 @@ ATExecForceNoForceRowSecurity(Relation rel, bool force_rls)
 		elog(ERROR, "cache lookup failed for relation %u", relid);
 
 	((Form_pg_class) GETSTRUCT(tuple))->relforcerowsecurity = force_rls;
-	simple_heap_update(pg_class, &tuple->t_self, tuple);
+	simple_heap_update(pg_class, &tuple->t_self, tuple, &warm_update,
+			&modified_attrs);
 
 	/* keep catalog indexes current */
-	CatalogUpdateIndexes(pg_class, tuple);
+	CatalogUpdateIndexes(pg_class, tuple, warm_update, modified_attrs);
 
 	heap_close(pg_class, RowExclusiveLock);
 	heap_freetuple(tuple);
@@ -11948,6 +12079,8 @@ ATExecGenericOptions(Relation rel, List *options)
 	bool		repl_repl[Natts_pg_foreign_table];
 	Datum		datum;
 	Form_pg_foreign_table tableform;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	if (options == NIL)
 		return;
@@ -11994,8 +12127,8 @@ ATExecGenericOptions(Relation rel, List *options)
 	tuple = heap_modify_tuple(tuple, RelationGetDescr(ftrel),
 							  repl_val, repl_null, repl_repl);
 
-	simple_heap_update(ftrel, &tuple->t_self, tuple);
-	CatalogUpdateIndexes(ftrel, tuple);
+	simple_heap_update(ftrel, &tuple->t_self, tuple, &warm_update, &modified_attrs);
+	CatalogUpdateIndexes(ftrel, tuple, warm_update, modified_attrs);
 
 	/*
 	 * Invalidate relcache so that all sessions will refresh any cached plans
@@ -12278,6 +12411,9 @@ AlterRelationNamespaceInternal(Relation classRel, Oid relOid,
 	already_done = object_address_present(&thisobj, objsMoved);
 	if (!already_done && oldNspOid != newNspOid)
 	{
+		bool		warm_update;
+		Bitmapset	*modified_attrs;
+
 		/* check for duplicate name (more friendly than unique-index failure) */
 		if (get_relname_relid(NameStr(classForm->relname),
 							  newNspOid) != InvalidOid)
@@ -12290,8 +12426,9 @@ AlterRelationNamespaceInternal(Relation classRel, Oid relOid,
 		/* classTup is a copy, so OK to scribble on */
 		classForm->relnamespace = newNspOid;
 
-		simple_heap_update(classRel, &classTup->t_self, classTup);
-		CatalogUpdateIndexes(classRel, classTup);
+		simple_heap_update(classRel, &classTup->t_self, classTup, &warm_update,
+				&modified_attrs);
+		CatalogUpdateIndexes(classRel, classTup, warm_update, modified_attrs);
 
 		/* Update dependency on schema if caller said so */
 		if (hasDependEntry &&
